#include <Arduino_LSM9DS1.h>

const float gyroscopeThreshold = 300;
const int numSamples = 64;
int samplesRead = numSamples;
int nbGesture = 0; 

void setup() {
  Serial.begin(9600);
  while (!Serial);

  if (!IMU.begin()) {
    Serial.println("Failed to initialize IMU!");
    while (1);
  }

  pinMode(22, OUTPUT);
  pinMode(23, OUTPUT);
  pinMode(24, OUTPUT);
  digitalWrite(22, HIGH);
  digitalWrite(23, HIGH);
  digitalWrite(24, HIGH);

  // wypisanie nagłówka
  Serial.println("aX,aY,aZ,gX,gY,gZ");
}

void loop() {
  float aX, aY, aZ, gX, gY, gZ;

  if (nbGesture <= 20) {
    digitalWrite(22, LOW);
  }
  if (nbGesture >= 21 && nbGesture <= 40) {
    digitalWrite(22, HIGH);
    digitalWrite(23, LOW);
  }
  if (nbGesture >= 41 && nbGesture <= 60) {
    digitalWrite(23, HIGH);
    digitalWrite(24, LOW);
  }
  if (nbGesture >= 61 && nbGesture <= 80) {
    digitalWrite(24, HIGH);
    digitalWrite(22, LOW);
  }
  if (nbGesture >= 81 && nbGesture <= 101) {
    digitalWrite(22, HIGH);
    digitalWrite(23, LOW);
  }
  if (nbGesture >= 101 && nbGesture <= 120) {
    digitalWrite(23, HIGH);
    digitalWrite(24, LOW);
  }

  if (nbGesture >= 121) {
    digitalWrite(22, LOW);
    digitalWrite(23, LOW);
    digitalWrite(24, LOW);
    delay(1000000);
  }

  // oczekiwanie na ruch 
  while (samplesRead == numSamples) {
    if (IMU.gyroscopeAvailable()) {
      // odczyt danych przyspieszenia
      IMU.readGyroscope(gX, gY, gZ);

      // suma wartości bezwzględnych
      float gSum = fabs(gX) + fabs(gY) + fabs(gZ);

      // sprawdzenie, czy wartość jest powyżej progu
      if (gSum >= gyroscopeThreshold) {
        // reset licznika ilości odczytanych próbek
        samplesRead = 0;
        break;
      }
    }
  }

  // sprawdzenie, czy wszystkie wymagane próbki zostały odczytane
  while (samplesRead < numSamples) {
    // sprawdzenie, czy dostępne są nowe dane 
    if (IMU.accelerationAvailable() && IMU.gyroscopeAvailable()) {
      // odczyt nowych danych
      IMU.readAcceleration(aX, aY, aZ);
      IMU.readGyroscope(gX, gY, gZ);
      samplesRead++;
      // wypisanie danych w formacie CSV 
      Serial.print(aX, 3);
      Serial.print(',');
      Serial.print(aY, 3);
      Serial.print(',');
      Serial.print(aZ, 3);
      Serial.print(',');
      Serial.print(gX, 3);
      Serial.print(',');
      Serial.print(gY, 3);
      Serial.print(',');
      Serial.print(gZ, 3);
      Serial.println();

      if (samplesRead == numSamples) {
        // dodanie pustej linii po ostatniej próbce
        Serial.println();
        nbGesture++;
        digitalWrite(22, LOW);
        digitalWrite(23, LOW);
        digitalWrite(24, LOW);
        delay(500);
        digitalWrite(22, HIGH);
        digitalWrite(23, HIGH);
        digitalWrite(24, HIGH);
        delay(500);
      }
    }
  }
}
